package com.oreilly.jent.ejb.messageDriven;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.rmi.RemoteException;
import java.util.Enumeration;

import javax.ejb.EJBException;
import javax.ejb.FinderException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import com.oreilly.jent.ejb.Profile;
import com.oreilly.jent.ejb.containerManaged.ProfileHome;

public class ProfileProxyBean implements MessageDrivenBean, MessageListener {
  private MessageDrivenContext mContext;
  private ProfileHome mProfileHome;

  // Required create method.  Here, we lookup the home interface for the
  // Profile EJB we are acting as a proxy for.  We use the Profile's local
  // home interface, assuming that we're running in the same container.
  public void ejbCreate () {
    System.out.println("Create called on ProfileProxyBean.");
    try {
      Context ctx = new InitialContext();
      mProfileHome = 
        (ProfileHome)PortableRemoteObject.narrow(ctx.lookup("ejb/CMPProfile"),
                                                 ProfileHome.class);
    }
    catch (NamingException ne) {
      throw new EJBException("Failed to locate Profile home interface: " +
                             ne.getMessage());
    }
  }

  // Receive context from the container.
  public void setMessageDrivenContext(MessageDrivenContext ctx) {
    mContext = ctx;
  }

  // Required remove method - no action needed in our case.
  public void ejbRemove() {
    System.out.println("Remove called on ProfileProxyBean.");
  }

  // Implementation of message listener.  Here, we check the type of the
  // incoming message.  If it's other than a MapMessage, we ignore it.  If it
  // is a MapMessage, we interpret it as a set of new entry values for a
  // profile named by the "OWNER" field in the map.  We lookup the
  // corresponding Profile EJB, and set the entries according to the contents
  // of the MapMessage.
  public void onMessage(Message msg) {
    if (msg instanceof MapMessage) {
      MapMessage mMsg = (MapMessage)msg;
      try {
        String name = mMsg.getString("OWNER");
        if (name != null) {
          Profile prof = mProfileHome.findByPrimaryKey(name);
          Enumeration eNames = mMsg.getMapNames();
          while (eNames.hasMoreElements()) {
            String eName = (String)eNames.nextElement();
            String eVal = mMsg.getString(eName);
            if (!eName.equals("OWNER")) {
              prof.setEntry(eName, eVal);
            }
          }
        }
      }
      catch (JMSException je) {
        System.out.println("JMS error processing message to ProfileProxy: " +
                           je.getMessage());
      }
      catch (RemoteException re) {
        System.out.println("Remote exception while accessing profile: " +
                           re.getMessage());
      } 
      catch (FinderException fe) {
        System.out.println("Failed to find Profile named in message: " +
                           fe.getMessage());
      }
    }
    else {
      System.out.println("Non-MapMessage received by ProfileProxy, type = " +
                         msg.getClass().getName());
    }
  }
}
  
